package org.jboss.seam.selectitems;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;
import org.jboss.seam.contexts.Contexts;

@Name("org.jboss.seam.selectitems.selectItemsConfig")
@Scope(ScopeType.EVENT)
public class SelectItemsConfig {

	public static final String NO_SELECTION_VALUE = "org.jboss.seam.selectitems.SelectItemsPersistenceConfig.NULL";

	private String cacheRegion = "org/jboss/seam/selectitems";

	private String persistenceUnitJndiName;

	private boolean cache = false;

	private String noSelectionLabel;

	private boolean hideNoSelection = false;

	public boolean isCache() {
		return cache;
	}

	public void setCache(boolean cache) {
		this.cache = cache;
	}

	public boolean isHideNoSelection() {
		return hideNoSelection;
	}

	public void setHideNoSelection(boolean hideNoSelection) {
		this.hideNoSelection = hideNoSelection;
	}

	public String getNoSelectionLabel() {
		return noSelectionLabel;
	}

	public void setNoSelectionLabel(String noSelectionLabel) {
		this.noSelectionLabel = noSelectionLabel;
	}

	public String getPersistenceUnitJndiName() {
		return persistenceUnitJndiName;
	}

	public void setPersistenceUnitJndiName(String emfJndiName) {
		this.persistenceUnitJndiName = emfJndiName;
	}

	public static SelectItemsConfig instance() {
		if (!Contexts.isEventContextActive()) {
			throw new IllegalStateException("No active event scope");
		}
		return (SelectItemsConfig) Component.getInstance(
				SelectItemsConfig.class, ScopeType.EVENT, true);
	}

	public String getCacheRegion() {
		return cacheRegion;
	}

	public void setCacheRegion(String cacheRegion) {
		this.cacheRegion = cacheRegion;
	}

}
