package org.jboss.seam.selectitems.ui;

import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.el.ValueBinding;
import javax.faces.webapp.ConverterTag;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;

public class ConvertEntityTag extends ConverterTag {

	private static final String CONVERTER_ID = "org.jboss.seam.EntityConverter";

	private String entityClass;

	private String persistenceUnitJndiName;

	public String getEntityClass() {
		return entityClass;
	}

	public void setEntityClass(String entityClass) {
		this.entityClass = entityClass;
	}

	public String getPersistenceUnitJndiName() {
		return persistenceUnitJndiName;
	}

	public void setPersistenceUnitJndiName(String persistenceUnitJndiName) {
		this.persistenceUnitJndiName = persistenceUnitJndiName;
	}

	@Override
	public void setPageContext(PageContext arg0) {
		super.setPageContext(arg0);
		setConverterId(CONVERTER_ID);
	}

	@Override
	protected Converter createConverter() throws JspException {
		BasicEntityConverter converter = (BasicEntityConverter) super.createConverter();
		FacesContext facesContext = FacesContext.getCurrentInstance();
		setConverterEntityClass(facesContext, converter, entityClass);
		setConverterPersistenceUnitJndiName(facesContext, converter, persistenceUnitJndiName);
		return converter;
	}

	private static void setConverterEntityClass(FacesContext facesContext,
			BasicEntityConverter converter, String value) {
		if (value == null)
			return;
		if (UIComponentTag.isValueReference(value)) {
			ValueBinding vb = facesContext.getApplication().createValueBinding(
					value);
			converter.setEntityClass((String) vb.getValue(facesContext));
		} else {
			converter.setEntityClass(value);
		}
	}
	
	private static void setConverterPersistenceUnitJndiName(FacesContext facesContext,
			BasicEntityConverter converter, String value) {
		if (value == null)
			return;
		if (UIComponentTag.isValueReference(value)) {
			ValueBinding vb = facesContext.getApplication().createValueBinding(
					value);
			converter.setPersistenceUnitJndiName((String) vb.getValue(facesContext));
		} else {
			converter.setPersistenceUnitJndiName(value);
		}
	}

}
